<template src="./template.html"></template>
<script lang="ts">
// import { getModule } from "nuxt-property-decorator";
import { forEach } from "lodash";
import { Vue, Component, Prop } from "vue-property-decorator";
import { api, api_key_tiny_editor, regexEmail } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { Watch } from "nuxt-property-decorator";
// import axios from "axios";
// import UserModule from "~/store/user";
// import { Store } from "vuex";
@Component({
  components: {},
})
export default class SettingSellerReViewStoreComponent extends Vue {
  tab = 0;
  rating = 4.5;
  selected = [2];
  addReview = false;
  editReview = false;

  get storeId() {
    return this.$store.state.sellerStore.storeId;
  }
  singleReview: any = {};
  listImgReview = [];
  listImageRender = [];
  listImageRenderPost = [];
  listReview = [];

  avg = 0;
  loadingTable = false;
  loading = false;
  loadingId = "";
  form = {
    email: "",
    name: "",
    phoneNumber: "",
    rating: 0,
    content: "",
    title: "",
  };
  imageSrc = "";
  openEditDialog(item: any) {
    this.editReview = true;
    this.singleReview = item;
    this.listImageRender = item.images;
  }

  clearImg(chooseItem: any) {
    this.listImageRender = this.listImageRender.filter(
      (item) => item !== chooseItem
    );
  }

  clearImgPost(chooseItem: any) {
    this.listImageRenderPost = this.listImageRenderPost.filter(
      (item) => item !== chooseItem
    );
  }
  onGetAvg() {
    let total = 0;
    if (this.listReview.length) {
      this.listReview.forEach((item: any) => {
        total += item.rating;
      });
      this.avg = Math.round(total / this.listReview.length);
    } else {
      this.avg = 0;
    }
  }

  async mounted() {
    await this.onGetReview();
    this.onGetAvg();
  }
  async onGetReview() {
    try {
      this.loadingTable = true;
      const res = await this.$api.review.get(this.storeId);
      if (res?.data) {
        this.listReview = res?.data;
        this.onGetAvg();
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onDeleteReview(id: string) {
    try {
      const reviewId = id;
      this.loadingId = id;
      await this.$api.review.delete(this.storeId, reviewId);
      this.$pushNotification.success("Delete review success");
      this.onGetReview();
      this.onGetAvg();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingId = "";
    }
  }

  convertImage(url: string) {
    if (url.includes("data:image")) return url;
    return `${api}/${url}`;
  }

  async onApproveReview(id: string) {
    try {
      const reviewId = id;
      const body = {
        approved: true,
      };
      await this.$api.review.approve(this.storeId, reviewId, body);
      this.$pushNotification.success("Accept review success");
      this.onGetReview();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  onUploadImage() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }

  onChangeImage(e: any) {
    this.listImgReview = [];
    this.listImageRender = [];
    for (let item of e) {
      if (!item.type.includes("image/")) {
        continue;
      }
    }
    this.listImgReview = e;
    for (let item of e) {
      this.createImage(item);
    }
  }

  listImgReviewPost = [];

  onChangeImagePost(e: any) {
    this.listImgReviewPost = [];
    this.listImageRenderPost = [];
    for (let item of e) {
      if (!item.type.includes("image/")) {
        continue;
      }
    }
    this.listImgReviewPost = e;
    for (let item of e) {
      this.createImagePost(item);
    }
  }

  createImage(e: any) {
    const reader = new FileReader();
    reader.onload = (e) => {
      //@ts-ignore
      this.listImageRender.push(e.target.result);
    };
    reader.readAsDataURL(e);
  }

  createImagePost(e: any) {
    const reader = new FileReader();
    reader.onload = (e) => {
      //@ts-ignore
      this.listImageRenderPost.push(e.target.result);
    };
    reader.readAsDataURL(e);
  }

  closeAddReview() {
    this.addReview = false;
    this.listImageRender = [];
  }
  async onPostReview() {
    try {
      if (!regexEmail.test(this.form.email)) {
        return this.$pushNotification.error("Email invalid");
      }
      if (
        !this.form.email ||
        !this.form.name ||
        !this.form.rating ||
        !this.form.content ||
        !this.form.title
      ) {
        return this.$pushNotification.error("Please fill all field");
      }
      const formData = new FormData();
      formData.append("email", this.form.email);
      formData.append("name", this.form.name);
      // @ts-ignore
      formData.append("rating", this.form.rating);
      formData.append("content", this.form.content);
      formData.append("title", this.form.title);
      // @ts-ignore
      if (this.listImgReviewPost.length) {
        for (let img of this.listImgReviewPost) {
          formData.append("images", img);
        }
      }
      this.loading = true;
      await this.$api.review.post(this.storeId, formData);
      this.closeAddReview();
      this.onGetReview();
      this.$pushNotification.success("Add review successfully");
      this.form = {
        email: "",
        name: "",
        phoneNumber: "",
        rating: 0,
        content: "",
        title: "",
      };
      this.listImageRenderPost = [];
      this.onGetAvg();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  loadingEdit = false;

  async onEditReview() {
    try {
      if (!regexEmail.test(this.singleReview.email)) {
        return this.$pushNotification.error("Email invalid");
      }

      const formData = new FormData();
      formData.append("email", this.singleReview.email);
      formData.append("name", this.singleReview.name);
      // @ts-ignore
      formData.append("rating", this.singleReview.rating);
      formData.append("content", this.singleReview.content);
      formData.append("title", this.singleReview.title);

      // @ts-ignore
      if (this.listImgReview.length) {
        for (let img of this.listImgReview) {
          formData.append("images", img);
        }
      } else {
        for (let img of this.listImageRender) {
          formData.append("images", img);
        }
      }
      this.loadingEdit = true;
      await this.$api.review.edit(
        this.storeId,
        this.singleReview._id,
        formData
      );
      this.editReview = false;
      this.onGetReview();
      this.$pushNotification.success("Edit review successfully");
      this.form = {
        email: "",
        name: "",
        phoneNumber: "",
        rating: 0,
        content: "",
        title: "",
      };
      this.listImageRender = [];
      this.onGetAvg();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingEdit = false;
    }
  }
}
</script>
<style lang="scss" scoped>
.image-cmt {
  min-width: 55px;
  max-width: 56px;
  width: 100%;
  height: 56px;
}
</style>
